var NAVTREE =
[
  [ "TeamTalk 4 C-API DLL", "index.html", [
    [ "Introduction", "index.html#intro", null ],
    [ "TeamTalk 4 SDK Support", "index.html#support", null ],
    [ "Server Setup Guide", "serversetup.html", [
      [ "Configurating the TeamTalk Server", "serversetup.html#srvconfig", null ],
      [ "Starting a TeamTalk Server", "serversetup.html#srvstart", null ],
      [ "Installing the TeamTalk 4 NT Service", "serversetup.html#ntservice", [
        [ "Installing multiple NT Services", "serversetup.html#mntservice", null ]
      ] ],
      [ "TeamTalk 4 PHP Admin for remote administration", "serversetup.html#ttphpadmin", null ]
    ] ],
    [ "Client Setup Guide", "clientsetup.html", null ],
    [ "Client Examples", "examples.html", [
      [ "Qt Client Example (TeamTalk4)", "examples.html#qtexample", null ],
      [ "MFC Client Example (TeamTalkMFC)", "examples.html#mfcexample", null ],
      [ "Server Log Console Example (ttserverlog)", "examples.html#ttserverlog", null ]
    ] ],
    [ "Client Programming Guide", "stepbystep.html", [
      [ "Step 1: Create a TeamTalk Client Instance", "stepbystep.html#stepinit", null ],
      [ "Step 2: Initialize Sound and Video Devices", "stepbystep.html#stepdevs", null ],
      [ "Step 3: Connect to a TeamTalk Server", "stepbystep.html#stepconnect", null ],
      [ "Step 4: Log on to a TeamTalk Server", "stepbystep.html#steplogon", null ],
      [ "Step 5: Join a channel on the TeamTalk Server", "stepbystep.html#stepjoin", null ],
      [ "Step 6: Transmit data to users in a Channel", "stepbystep.html#steptx", null ]
    ] ],
    [ "ChangeLog", "changelog.html", [
      [ "TeamTalk 4 SDK v. 4.5a release", "changelog.html#v45arelease", [
        [ "New features in v. 4.5a", "changelog.html#v45afeatures", [
          [ "Stream Media Files to Channel", "changelog.html#v45astream", null ],
          [ "Login Attempt Limit", "changelog.html#v45alogin", null ],
          [ "Ban user by IP-address", "changelog.html#v45aipban", null ]
        ] ],
        [ "API Changes in v4.5a", "changelog.html#v45aapi", null ]
      ] ],
      [ "TeamTalk 4 SDK v. 4.4a release", "changelog.html#v44arelease", [
        [ "New features in v. 4.4a", "changelog.html#v44afeatures", [
          [ "Support for Windows Audio Session", "changelog.html#v44awasapi", null ],
          [ "Restart Sound System", "changelog.html#v44arestartsnd", null ],
          [ "Automatic resampling of unsupported sample rates", "changelog.html#v44aautoresam", null ],
          [ "Operator receive-only channel type", "changelog.html#v44aoprecv", null ],
          [ "Encrypted client (Pro-Edition) can connect to non-encrypted servers", "changelog.html#v44anoncrypt", null ],
          [ "Unicode video device names", "changelog.html#v44aviduni", null ]
        ] ],
        [ "API Changes in v4.4a", "changelog.html#v4aaapi", null ]
      ] ],
      [ "TeamTalk 4 SDK v. 4.3a release", "changelog.html#v43arelease", [
        [ "New features in v. 4.3a", "changelog.html#v43afeatures", [
          [ "Share Desktop Applications", "changelog.html#v43adesktop", null ],
          [ "Join channel after login", "changelog.html#v43ainitialchan", null ],
          [ "Automatically become channel operator", "changelog.html#v43aautoop", null ],
          [ "Custom message type", "changelog.html#v43acustommsgtype", null ],
          [ "Query maximum UDP packet size", "changelog.html#v43aquerymtu", null ],
          [ "Access raw audio data", "changelog.html#v43aaudioblock", null ],
          [ "Get name of file being recorded to", "changelog.html#v43aaudiofilename", null ],
          [ "Reset recorded audio file", "changelog.html#v43aresetaudiofile", null ],
          [ "See own video stream", "changelog.html#v43achanechovideo", null ],
          [ "Free-for-all option in classrooms", "changelog.html#v43afreeforall", null ]
        ] ],
        [ "API Changes in v4.3a", "changelog.html#v43aapi", null ]
      ] ],
      [ "TeamTalk 4 SDK v. 4.2a release", "changelog.html#v42arelease", [
        [ "New features in v. 4.2a", "changelog.html#v42afeatures", [
          [ "Muxed audio files", "changelog.html#v42amuxaudio", null ],
          [ "Windows XP/Vista/7 Firewall", "changelog.html#v42awinfirewall", null ],
          [ "Modify \"talking\" delay", "changelog.html#v42atalkdelay", null ],
          [ "VBR audio codecs", "changelog.html#v42avbrcodecs", null ],
          [ "CELT updated to version 0.11", "changelog.html#v42acelt011", null ],
          [ "IPv6 support (Windows 2000 no longer supported)", "changelog.html#v42aipv6", null ]
        ] ],
        [ "API Changes in v4.2a", "changelog.html#v42aapi", [
          [ "Removed API functions", "changelog.html#v42aapiremove", null ]
        ] ]
      ] ],
      [ "TeamTalk 4 SDK v. 4.1a release", "changelog.html#v41arelease", [
        [ "New Features in v. 4.1a", "changelog.html#v41afeatures", [
          [ "Mac OS X and Windows Mobile platforms", "changelog.html#v41aplatforms", null ],
          [ "Echo Cancellation", "changelog.html#v41aecho", null ],
          [ "Classroom channel-type", "changelog.html#v41aclassroom", null ],
          [ "Channel based audio configuration", "changelog.html#v41aaudiocfg", null ],
          [ "Server Statistics", "changelog.html#v41asrvstats", null ],
          [ "Simpler video extraction", "changelog.html#v41avideo", null ]
        ] ],
        [ "API Changes in v4.1a", "changelog.html#v41aapi", null ]
      ] ],
      [ "TeamTalk 4 SDK v. 4.0c release", "changelog.html#v40crelease", [
        [ "New Features in v. 4.0c", "changelog.html#v40cfeatures", [
          [ "Note-field and user-data for user accounts", "changelog.html#v40cuseraccount", null ],
          [ "Get \"my\" User Account", "changelog.html#v40cmyaccount", null ],
          [ "Swap @c HWND for events", "changelog.html#v40cswaphwnd", null ],
          [ "Extract all Users on the Server", "changelog.html#v40cserverusers", null ]
        ] ],
        [ "API Changes in v4.0c", "changelog.html#v40capi", null ],
        [ "Bug fixes in v. 4.0c", "changelog.html#v40cbugfixes", null ]
      ] ],
      [ "TeamTalk 4 SDK v. 4.0a release", "changelog.html#v40arelease", [
        [ "New Features in v. 4.0a", "changelog.html#v40afeatures", [
          [ "Video Capturing from WebCams", "changelog.html#chvidcap", null ],
          [ "User Accounts", "changelog.html#chuseradmin", null ],
          [ "Track Command Completion", "changelog.html#chcmdid", null ],
          [ "Improved P2P Connections", "changelog.html#chp2p", null ],
          [ "Support for CELT audio codec", "changelog.html#chcelt", null ]
        ] ],
        [ "API Changes in v. 4.0a", "changelog.html#v40aapi", null ]
      ] ]
    ] ],
    [ "TODO List", "todolist.html", [
      [ "Known Issues", "todolist.html#tt4todo", [
        [ "Stereo MP3 files report incorrect time", "todolist.html#bugmp3stereo", null ],
        [ "Denoising only works for mono codecs", "todolist.html#bugpreprocess", null ],
        [ "Jitter-buffer stop working after a while", "todolist.html#bugjitter", null ]
      ] ]
    ] ],
    [ "License TeamTalk 4 SDK", "license.html", [
      [ "Purchase License", "license.html#purchase", null ]
    ] ],
    [ "Modules", "modules.html", "modules" ],
    [ "Classes", null, [
      [ "Class List", "annotated.html", "annotated" ],
      [ "Class Members", "functions.html", [
        [ "All", "functions.html", null ],
        [ "Variables", "functions_vars.html", null ]
      ] ]
    ] ],
    [ "Files", null, [
      [ "File List", "files.html", "files" ],
      [ "File Members", "globals.html", [
        [ "All", "globals.html", "globals_dup" ],
        [ "Functions", "globals_func.html", null ],
        [ "Typedefs", "globals_type.html", null ],
        [ "Enumerations", "globals_enum.html", null ],
        [ "Enumerator", "globals_eval.html", "globals_eval" ],
        [ "Macros", "globals_defs.html", null ]
      ] ]
    ] ]
  ] ]
];

var NAVTREEINDEX =
[
"_team_talk4_8h.html",
"_team_talk4_8h.html#gac65a4e162a077add68867b1483b129cf",
"_team_talk4_8h.html#ggafc4bdfbf2ff7f70d54e072c3fe3f2c6ca5eb543aa50c822794890a7beaecbb9bb",
"group__desktopshare.html#ga774e2ca94287587e141c55736e38efe3",
"group__sounddevices.html#gaba2287f0fa90e65009287cd8f8defa66",
"struct_media_file_info.html"
];

var SYNCONMSG = 'click to disable panel synchronisation';
var SYNCOFFMSG = 'click to enable panel synchronisation';
var navTreeSubIndices = new Array();

function getData(varName)
{
  var i = varName.lastIndexOf('/');
  var n = i>=0 ? varName.substring(i+1) : varName;
  return eval(n.replace(/\-/g,'_'));
}

function stripPath(uri)
{
  return uri.substring(uri.lastIndexOf('/')+1);
}

function stripPath2(uri)
{
  var i = uri.lastIndexOf('/');
  var s = uri.substring(i+1);
  var m = uri.substring(0,i+1).match(/\/d\w\/d\w\w\/$/);
  return m ? uri.substring(i-6) : s;
}

function localStorageSupported()
{
  try {
    return 'localStorage' in window && window['localStorage'] !== null && window.localStorage.getItem;
  }
  catch(e) {
    return false;
  }
}


function storeLink(link)
{
  if (!$("#nav-sync").hasClass('sync') && localStorageSupported()) {
      window.localStorage.setItem('navpath',link);
  }
}

function deleteLink()
{
  if (localStorageSupported()) {
    window.localStorage.setItem('navpath','');
  } 
}

function cachedLink()
{
  if (localStorageSupported()) {
    return window.localStorage.getItem('navpath');
  } else {
    return '';
  }
}

function getScript(scriptName,func,show)
{
  var head = document.getElementsByTagName("head")[0]; 
  var script = document.createElement('script');
  script.id = scriptName;
  script.type = 'text/javascript';
  script.onload = func; 
  script.src = scriptName+'.js'; 
  if ($.browser.msie && $.browser.version<=8) { 
    // script.onload does not work with older versions of IE
    script.onreadystatechange = function() {
      if (script.readyState=='complete' || script.readyState=='loaded') { 
        func(); if (show) showRoot(); 
      }
    }
  }
  head.appendChild(script); 
}

function createIndent(o,domNode,node,level)
{
  var level=-1;
  var n = node;
  while (n.parentNode) { level++; n=n.parentNode; }
  var imgNode = document.createElement("img");
  imgNode.style.paddingLeft=(16*level).toString()+'px';
  imgNode.width  = 16;
  imgNode.height = 22;
  imgNode.border = 0;
  if (node.childrenData) {
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() {
      if (node.expanded) {
        $(node.getChildrenUL()).slideUp("fast");
        node.plus_img.src = node.relpath+"ftv2pnode.png";
        node.expanded = false;
      } else {
        expandNode(o, node, false, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
    imgNode.src = node.relpath+"ftv2pnode.png";
  } else {
    imgNode.src = node.relpath+"ftv2node.png";
    domNode.appendChild(imgNode);
  } 
}

var animationInProgress = false;

function gotoAnchor(anchor,aname,updateLocation)
{
  var pos, docContent = $('#doc-content');
  if (anchor.parent().attr('class')=='memItemLeft' ||
      anchor.parent().attr('class')=='fieldtype' ||
      anchor.parent().is(':header')) 
  {
    pos = anchor.parent().position().top;
  } else if (anchor.position()) {
    pos = anchor.position().top;
  }
  if (pos) {
    var dist = Math.abs(Math.min(
               pos-docContent.offset().top,
               docContent[0].scrollHeight-
               docContent.height()-docContent.scrollTop()));
    animationInProgress=true;
    docContent.animate({
      scrollTop: pos + docContent.scrollTop() - docContent.offset().top
    },Math.max(50,Math.min(500,dist)),function(){
      if (updateLocation) window.location.href=aname;
      animationInProgress=false;
    });
  }
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  node.expanded = false;
  a.appendChild(node.label);
  if (link) {
    var url;
    if (link.substring(0,1)=='^') {
      url = link.substring(1);
      link = url;
    } else {
      url = node.relpath+link;
    }
    a.className = stripPath(link.replace('#',':'));
    if (link.indexOf('#')!=-1) {
      var aname = '#'+link.split('#')[1];
      var srcPage = stripPath($(location).attr('pathname'));
      var targetPage = stripPath(link.split('#')[0]);
      a.href = srcPage!=targetPage ? url : "javascript:void(0)"; 
      a.onclick = function(){
        storeLink(link);
        if (!$(a).parent().parent().hasClass('selected'))
        {
          $('.item').removeClass('selected');
          $('.item').removeAttr('id');
          $(a).parent().parent().addClass('selected');
          $(a).parent().parent().attr('id','selected');
        }
        var anchor = $(aname);
        gotoAnchor(anchor,aname,true);
      };
    } else {
      a.href = url;
      a.onclick = function() { storeLink(link); }
    }
  } else {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() {
    if (!node.childrenUL) {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  (function (){ // retry until we can scroll to the selected item
    try {
      var navtree=$('#nav-tree');
      navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
    } catch (err) {
      setTimeout(arguments.callee, 0);
    }
  })();
}

function expandNode(o, node, imm, showRoot)
{
  if (node.childrenData && !node.expanded) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        expandNode(o, node, imm, showRoot);
      }, showRoot);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      } if (imm || ($.browser.msie && $.browser.version>8)) { 
        // somehow slideDown jumps to the start of tree for IE9 :-(
        $(node.getChildrenUL()).show();
      } else {
        $(node.getChildrenUL()).slideDown("fast");
      }
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
    }
  }
}

function glowEffect(n,duration)
{
  n.addClass('glow').delay(duration).queue(function(next){
    $(this).removeClass('glow');next();
  });
}

function highlightAnchor()
{
  var aname = $(location).attr('hash');
  var anchor = $(aname);
  if (anchor.parent().attr('class')=='memItemLeft'){
    var rows = $('.memberdecls tr[class$="'+
               window.location.hash.substring(1)+'"]');
    glowEffect(rows.children(),300); // member without details
  } else if (anchor.parents().slice(2).prop('tagName')=='TR') {
    glowEffect(anchor.parents('div.memitem'),1000); // enum value
  } else if (anchor.parent().attr('class')=='fieldtype'){
    glowEffect(anchor.parent().parent(),1000); // struct field
  } else if (anchor.parent().is(":header")) {
    glowEffect(anchor.parent(),1000); // section header
  } else {
    glowEffect(anchor.next(),1000); // normal member
  }
  gotoAnchor(anchor,aname,false);
}

function selectAndHighlight(hash,n)
{
  var a;
  if (hash) {
    var link=stripPath($(location).attr('pathname'))+':'+hash.substring(1);
    a=$('.item a[class$="'+link+'"]');
  }
  if (a && a.length) {
    a.parent().parent().addClass('selected');
    a.parent().parent().attr('id','selected');
    highlightAnchor();
  } else if (n) {
    $(n.itemDiv).addClass('selected');
    $(n.itemDiv).attr('id','selected');
  }
  if ($('#nav-tree-contents .item:first').hasClass('selected')) {
    $('#nav-sync').css('top','30px');
  } else {
    $('#nav-sync').css('top','5px');
  }
  showRoot();
}

function showNode(o, node, index, hash)
{
  if (node && node.childrenData) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        showNode(o,node,index,hash);
      },true);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      }
      $(node.getChildrenUL()).show();
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
      var n = node.children[o.breadcrumbs[index]];
      if (index+1<o.breadcrumbs.length) {
        showNode(o,n,index+1,hash);
      } else {
        if (typeof(n.childrenData)==='string') {
          var varName = n.childrenData;
          getScript(n.relpath+varName,function(){
            n.childrenData = getData(varName);
            node.expanded=false;
            showNode(o,node,index,hash); // retry with child node expanded
          },true);
        } else {
          var rootBase = stripPath(o.toroot.replace(/\..+$/, ''));
          if (rootBase=="index" || rootBase=="pages" || rootBase=="search") {
            expandNode(o, n, true, true);
          }
          selectAndHighlight(hash,n);
        }
      }
    }
  } else {
    selectAndHighlight(hash);
  }
}

function getNode(o, po)
{
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
      i==l);
  }
}

function gotoNode(o,subIndex,root,hash,relpath)
{
  var nti = navTreeSubIndices[subIndex][root+hash];
  o.breadcrumbs = $.extend(true, [], nti ? nti : navTreeSubIndices[subIndex][root]);
  if (!o.breadcrumbs && root!=NAVTREE[0][1]) { // fallback: show index
    navTo(o,NAVTREE[0][1],"",relpath);
    $('.item').removeClass('selected');
    $('.item').removeAttr('id');
  }
  if (o.breadcrumbs) {
    o.breadcrumbs.unshift(0); // add 0 for root node
    showNode(o, o.node, 0, hash);
  }
}

function navTo(o,root,hash,relpath)
{
  var link = cachedLink();
  if (link) {
    var parts = link.split('#');
    root = parts[0];
    if (parts.length>1) hash = '#'+parts[1];
    else hash='';
  }
  if (hash.match(/^#l\d+$/)) {
    var anchor=$('a[name='+hash.substring(1)+']');
    glowEffect(anchor.parent(),1000); // line number
    hash=''; // strip line number anchors
    //root=root.replace(/_source\./,'.'); // source link to doc link
  }
  var url=root+hash;
  var i=-1;
  while (NAVTREEINDEX[i+1]<=url) i++;
  if (i==-1) { i=0; root=NAVTREE[0][1]; } // fallback: show index
  if (navTreeSubIndices[i]) {
    gotoNode(o,i,root,hash,relpath)
  } else {
    getScript(relpath+'navtreeindex'+i,function(){
      navTreeSubIndices[i] = eval('NAVTREEINDEX'+i);
      if (navTreeSubIndices[i]) {
        gotoNode(o,i,root,hash,relpath);
      }
    },true);
  }
}

function showSyncOff(n,relpath)
{
    n.html('<img src="'+relpath+'sync_off.png" title="'+SYNCOFFMSG+'"/>');
}

function showSyncOn(n,relpath)
{
    n.html('<img src="'+relpath+'sync_on.png" title="'+SYNCONMSG+'"/>');
}

function toggleSyncButton(relpath)
{
  var navSync = $('#nav-sync');
  if (navSync.hasClass('sync')) {
    navSync.removeClass('sync');
    showSyncOff(navSync,relpath);
    storeLink(stripPath2($(location).attr('pathname'))+$(location).attr('hash'));
  } else {
    navSync.addClass('sync');
    showSyncOn(navSync,relpath);
    deleteLink();
  }
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;
  o.node.expanded = false;
  o.node.isLast = true;
  o.node.plus_img = document.createElement("img");
  o.node.plus_img.src = relpath+"ftv2pnode.png";
  o.node.plus_img.width = 16;
  o.node.plus_img.height = 22;

  if (localStorageSupported()) {
    var navSync = $('#nav-sync');
    if (cachedLink()) {
      showSyncOff(navSync,relpath);
      navSync.removeClass('sync');
    } else {
      showSyncOn(navSync,relpath);
    }
    navSync.click(function(){ toggleSyncButton(relpath); });
  }

  navTo(o,toroot,window.location.hash,relpath);

  $(window).bind('hashchange', function(){
     if (window.location.hash && window.location.hash.length>1){
       var a;
       if ($(location).attr('hash')){
         var clslink=stripPath($(location).attr('pathname'))+':'+
                               $(location).attr('hash').substring(1);
         a=$('.item a[class$="'+clslink+'"]');
       }
       if (a==null || !$(a).parent().parent().hasClass('selected')){
         $('.item').removeClass('selected');
         $('.item').removeAttr('id');
       }
       var link=stripPath2($(location).attr('pathname'));
       navTo(o,link,$(location).attr('hash'),relpath);
     } else if (!animationInProgress) {
       $('#doc-content').scrollTop(0);
       $('.item').removeClass('selected');
       $('.item').removeAttr('id');
       navTo(o,toroot,window.location.hash,relpath);
     }
  })

  $(window).load(showRoot);
}

